/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.CuponConvenioDAO;
import com.rjconsultores.ventaboletos.entidad.CuponConvenio;
import com.rjconsultores.ventaboletos.entidad.TipoConvenio;
import com.rjconsultores.ventaboletos.service.CuponConvenioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Shiro
 */
@Service("cuponConvenioService")
public class CuponConvenioServiceImpl implements CuponConvenioService{

    @Autowired
    private CuponConvenioDAO cuponConvenioDAO;
    public List<CuponConvenio> obtenerTodos() {
        return cuponConvenioDAO.obtenerTodos();
    }

    public CuponConvenio obtenerID(Integer id) {
        return cuponConvenioDAO.obtenerID(id);
    }

    @Transactional
    public CuponConvenio suscribir(CuponConvenio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return cuponConvenioDAO.suscribir(entidad);
    }

    @Transactional
    public CuponConvenio actualizacion(CuponConvenio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return cuponConvenioDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(CuponConvenio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        cuponConvenioDAO.actualizacion(entidad);
    }

    public List<CuponConvenio> pesquisar(TipoConvenio tipoConvenio) {

         return cuponConvenioDAO.pesquisar(tipoConvenio);
    }

}
